
#property indicator_chart_window
//#property indicator_separate_window
#property indicator_buffers 6
//---
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 2
#property indicator_width5 1
#property indicator_width6 1
//---
#property indicator_style1 STYLE_SOLID
#property indicator_style2 STYLE_SOLID
#property indicator_style3 STYLE_SOLID
#property indicator_style4 STYLE_SOLID
#property indicator_style5 STYLE_SOLID
#property indicator_style6 STYLE_SOLID
//---
#property indicator_color1 DeepSkyBlue
#property indicator_color2 SlateGray
#property indicator_color3 Orange
#property indicator_color4 Magenta
#property indicator_color5 Red
#property indicator_color6 Yellow

//---
extern int Points        =  100;
extern double ChannelMA  =  3; //  /1    
extern int Border        =  0; //  
       int Outloss       =  0;
extern int Porog         =  500;
extern bool can          =  false;
extern bool tr           =  true;// 
extern bool zigzag       =  true;
extern bool ShowComment  =  false;

//---
double zz[],hm,lm,ha[],la[],sa[],dhm,dlm,dha[],dla[];
double fxH[],fxL[],di,smch,pdhm,pdlm;
int fs,ai,bi,ta,tb;
double HL,HLp,HL1,k,k0;
double Outloss1,Border1,Porog1;
double topS0,botS0,topS1,botS1; // ,    (. .)
int i,bar,trend,trendd;
int coef;
//+------------------------------------------------------------------+
int init() 
//+------------------------------------------------------------------+
{

   coef=10;
   if(Digits==3 || Digits == 5) coef=1;
   
   smch=2.0/(1+ChannelMA);
   Porog1 =Porog *Point;
   Border1=Border*Point;
    //------------------------------------------------------
   if (Points!=0 ) di=Points/coef*Point;else return(0);      
      
  
   
   IndicatorBuffers(8);
   if(zigzag)SetIndexStyle(0,DRAW_SECTION);else SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(0,zz);// 
   SetIndexEmptyValue(0, 0.0);
   
   if(can)
       {SetIndexStyle(1,DRAW_SECTION);
        SetIndexStyle(2,DRAW_SECTION);}
   else{SetIndexStyle(1,DRAW_NONE);
        SetIndexStyle(2,DRAW_NONE);}
   
   SetIndexBuffer(1,ha);//
   SetIndexBuffer(2,la);//
   
   SetIndexStyle(3,DRAW_SECTION);


   SetIndexBuffer(3,sa);//
   SetIndexBuffer(4,dha);//
   SetIndexBuffer(5,dla);//
   SetIndexBuffer(6,fxH);
   SetIndexBuffer(7,fxL);
   
   SetIndexLabel(0,"ZZ_Main");
   SetIndexLabel(1,"ZZ_High");
   SetIndexLabel(2,"ZZ_Low");
   SetIndexLabel(3,"ZZ_Middle");
   
   IndicatorDigits(Digits);

   return(0); 
}

//+------------------------------------------------------------------+
int start() 
//+------------------------------------------------------------------+
{
   int n,cbi;
   int IC=IndicatorCounted();
   if (IC>3) cbi=Bars-IC+1;
   else 
   {
      cbi=Bars-2;
      hm=High[Bars-1]; //
      lm=Low[Bars-1];
      
      dhm=High[Bars-1]; //
      dlm=Low[Bars-1];
      
      
      ai=Bars-2;//
      bi=Bars-1;
      fs=0;
   }
   //---
   for (i=cbi; i>=0; i--) //   
   {
      fxH[i]=High[i];  
      fxL[i]=Low[i];
   }

   //---
   for (i=cbi; i>=0; i--) //i>0
   {

      
      //-------------------Trigger----------------------------
      if (i==0) 
      {
         if (ta!=Time[ai]) {ai++; ta=Time[ai];} 
         if (tb!=Time[bi]) {bi++; tb=Time[bi];}
      }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

      if (fxH[i]-fxL[i]>=di) //            
      { 
         //------------1---------------//
         if ((fxH[i]+fxL[i])/2>=(ha[i+1]+la[i+1])/2) 
         {
            hm=fxH[i]; //   
            lm=hm-di; //  -

          if (fs==2)
           {
            zz[bi]=Low[bi];
            pdlm=dlm;
            botS1=botS0;botS0=smch*zz[bi]+(1-smch)*botS1;
           } // fs=1 -           
           
            if(Low[bi]>dhm) {dhm=fxH[i];}  //
            
                  dlm=Low[bi]; ////dlm=smch*zz[bi]+(1-smch)*zz[bi+1];
            
            ai=i;
            ta=Time[ai]; 
            fs=1;
         } 
         else                         
         //------------2---------------//
         { 
            lm=fxL[i]; 
            hm=lm+di; ////////////////////////////////////////////
            
            
           if (fs==1) 
            {
            zz[ai]=High[ai];
            pdhm=dhm;
            topS1=topS0;topS0=smch*zz[ai]+(1-smch)*topS1;
            }

                         dhm=High[ai]; //
        if(High[ai]<dlm) {dlm=fxL[i];}             
             
         
            bi=i;
            tb=Time[bi]; 
            fs=2;
         }
      } 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
      
      else //    
    
      //------------------------fs=1----------------------------------//
      if (fxH[i]>hm) 
      {
         
         hm=fxH[i]; 
         lm=hm-di; //la[i-1]
         
         if (fs==2)
            {
            zz[bi]=Low[bi];
            pdlm=dlm;
            botS1=botS0;botS0=smch*zz[bi]+(1-smch)*botS1;
            } 

          if(Low[bi]>dhm) {dhm=fxH[i];    } // 
                          dlm=Low[bi]; ////
                          
         
         
         ai=i;
         ta=Time[ai]; 
         fs=1;//?// fs=1 - 
      }
      else
      //-------------------------fs=2---------------------------------//
      if (fxL[i]<lm) 
      { 
         
         
         lm=fxL[i]; 
         hm=lm+di; 
         //pdhm=zz[ai];//
         if (fs==1) 
          {
          zz[ai]=High[ai];
          pdhm=dhm;
           topS1=topS0;topS0=smch*zz[ai]+(1-smch)*topS1;
          }

                         dhm=High[ai];//               
        if(High[ai]<dlm) {dlm=fxL[i];          }    //  
                                 //
        

         
         bi=i; 
         tb=Time[bi];
         fs=2;
      }
      //----------------------------------------------------------------

 
        
         
        ha[i]=hm;//
        la[i]=lm;
        sa[i]=(ha[i]+la[i])/2;
   
         dha[i]=topS0+Border1;//      
         dla[i]=botS0-Border1;//
   
      
      
/* */           
       if(High[i-1]>dha[i]) trend=1; // .
       if(Low[i-1]<dla[i]) trend=0; //  
  
      if((dha[i]-dla[i])>Porog1)//  
       {
       if(trend==1)  dla[i]=dha[i]-Porog1;////
       if(trend==0)  dha[i]=dla[i]+Porog1; //
    
       }
    
     if(tr)
      { 
       if(High[i-1]> dha[i]) trendd=1; // .
       if(Low [i-1]< dla[i]) trendd=0; //  
         
       if(trendd==1) {sa[i]=dha[i];}if(trendd==0) {sa[i]=dla[i];}
      }else sa[i]=(dha[i]+dla[i])/2;
      
 
      
      
      //dha[i]=MathAbs(dhm-dlm)*100000;dla[i]=0;// 
      //
      //======================i=0======================================== 
      if (i==0) 
      {
         if (fs==1) for (n=0; n<=bi; n++) zz[n]=0.0;
         if (fs==2) for (n=0; n<=ai; n++) zz[n]=0.0;

         zz[ai]=fxH[ai];
         zz[bi]=fxL[bi];
         dha[0]= dha[1];
         dla[0]= dla[1];
         sa[0]=sa[1];
      }
   } 
   if (ShowComment)Comment
   (
     "ai = ",ai,"\n",
     "bi = ",bi,"\n",
     " = ",DoubleToStr(dha[1],5),"\n",
     "  = ",DoubleToStr(dla[1],5),"\n","\n",
     "  = ",DoubleToStr((dha[1]-dla[1])*100000,0),"\n"
   );

   return(0); 
}

